# Description

Script to transfer trained parameters from the `source` network to the `target` network and finetune the final model.
Only layers with matching names are considered to transfer.

_Note_: If the layer parameters shape depends on the input shape,
then additional checks might be required (see the script for the details) as the parameters will be copied without checking.
For example, the fully-connected layers are suffer from this, but the convolutional layers are not.

# Usage

```
main_transfer.py -b gpu -z 32 -e 10 --data_root <path> --source_model <path> --target_model_name <name> --target_model <path>
```

Noticeable command line parameters:
- `--help` is an option to list of all accessible parameters.
- `-b <name>` is the backend to use (`gpu`, `mkl`, `cpu`).
- `-z <number>` is an option to set batch size.
- `-e <number>` is an option to set epoch count.
- `--save_path <path>` with `--serialize <number>` are options to save model and learning state every X epochs.
- `--model_file <path>` is a path to load saved model and continue learning.
- `--data_root <path>` is a path to the training and validation data directory.
- `--restrict_dataset <number>` is an option to use only X (0 = all) samples from training and validation datasets. 
    Works only for inmemory data loaders (see script for details).
- `--source_model <path>` is a source model (e.g. VGG_D.p).
- `--target_model_name <name>` is a a target model (${MODEL}).
- `--target_model <path>` is a final model (model_${MODEL}.prm).
