# Description

Script to train autoencoders. There are 2 variants:
- Train single autoencoder.
- Train stack of autoencoders.

The training is splitted in two steps:
1. Training autoencoder.
2. Transferring trained weights to the classifier network and finetuning.

# Usage

```
main_train_stacked_autoencoder.py -b gpu -z 32 -e 10 --data_root <path> --model_name <name> --save_path <path> --serialize 5
main_transfer.py -b gpu -z 32 -e 10 --data_root <path> --source_model <name> --target_model_name <name> --target_model <name>
```

Noticeable command line parameters for autoencoders:
- `--help` is an option to list of all accessible parameters.
- `-b <name>` is the backend to use (`gpu`, `mkl`, `cpu`).
- `-z <number>` is an option to set batch size.
- `-e <number>` is an option to set epoch count.
- `--save_path <path>` (model_${MODEL}.prm, e.g., MODEL=mlp2b2_128_ae_stacked) with `--serialize <number>` are options to save model and learning state every X epochs.
- `--model_file <path>` is an option to load saved model and continue learning.
- `--data_root <path>` is a path to the training and validation data directory.
- `--model_name <name>` is a model name. The full list of acessible names can be found in the `models` directory (${MODEL}).
- `--restrict_dataset <number>` is an option to use only X (0 = all) samples from training and validation datasets.
    Works only for inmemory data loaders (see script for details).
