# Description

The script for semantic segmentation tasks.

# Usage

```
main_segmentation.py -b gpu -z 32 -e 10 --data_root <path> --model_name <name> --inference_path <path>
```

Noticeable command line parameters:
- `--help` is an option to list of all accessible parameters.
- `-b <name>` is the backend to use (`gpu`, `mkl`, `cpu`).
- `-z <number>` is an option to set batch size.
- `-e <number>` is an option to set epoch count.
- `--save_path <path>` with `--serialize <number>` are options to save model and learning state every X epochs.
- `--model_file <path>` is a path to load saved model and continue training.
- `--data_root <path>` is a path to the training and validation data directory.
- `--model_name <name>` is a model name. The full list of acessible names can be found in the `models` directory (${MODEL}).
- `--restrict_dataset <number>` is an option to use only X (0 = all) samples from training and validation datasets.
    Works only for inmemory data loaders (see script for details).
- `--source_model <path>` is a source model to transfer parameters.
- `--inference_path <path>` is a directory to save inference (e.g., ./inference_${MODEL}).
