from models.mlp_models import *
from models.cnn_models import *
from models.ae_models import *
from models.tl_models import *
from models.rnn_models import *
import numpy as np


def get_model_generator(model_name):
    generator_name = "generate_" + model_name + "_model"
    return globals()[generator_name]

def get_weights_norm(model):
    pdict = model.get_description(get_weights=True)
    ldict = pdict['model']['config']['layers']
    norm = 0
    for layer in ldict:
        if ('params' in layer):
            params = layer['params']
            if ('W' in params):
                weights = params['W'].flatten()
                norm += np.dot(weights, weights)
    return norm ** 0.5
